<template>
  <v-card class="mx-auto" max-width="100%">
    <confirmation-modal :is-open="openModal" :modal-text="modalText" @confirm="confirmRegister" @cancel="cancelRegister" />
    <v-card-subtitle class="pb-0">
      <image-field v-model="patient.user.image" :disabled="disabled_user_info" :validation="imageValidation" />
      <v-divider />
      <v-form ref="form" lazy-validation>
        <v-container fluid>
          <select-field v-model="typeDocumentSelected" :items="typesDocument" field-name="Tipo de documento" @selectChange="changeSELECT" />
          <register-field-validation
            v-if="typeDocumentSelected==='DNI'"
            v-model="patient.user.document"
            field-name="DNI"
            :validation="DNIValidation"
            place-holder="Ingrese DNI"
            @inputChange="changeDNI"
          />
          <register-field-validation
            v-if="typeDocumentSelected==='CARNET EXTRANJERÍA'"
            v-model="patient.user.document"
            field-name="Carnet de extranjería"
            :validation="carnetValidation"
            place-holder="Ingrese Carnet de extranjería"
            @inputChange="changeCarnetOrPassport"
          />
          <register-field-validation
            v-if="typeDocumentSelected==='PASAPORTE'"
            v-model="patient.user.document"
            field-name="Pasaporte"
            :validation="passportValidation"
            place-holder="Ingrese Pasaporte"
            @inputChange="changeCarnetOrPassport"
          />
          <register-field-validation
            v-model="patient.user.name"
            :disabled="disabled_user_info || typeDocumentSelected==='DNI'"
            field-name="Nombre"
            :validation="nameValidation"
            place-holder="Ingrese Nombre"
          />
          <register-field-validation
            v-model="patient.user.fatherLastname"
            :disabled="disabled_user_info || typeDocumentSelected==='DNI'"
            field-name="Apellido Paterno"
            :validation="fatherLastnameValidation"
            place-holder="Ingrese Apellido Paterno"
          />
          <register-field-validation
            v-model="patient.user.motherLastname"
            :disabled="disabled_user_info || typeDocumentSelected==='DNI'"
            field-name="Apellido Materno "
            :validation="motherLastNameValidation"
            place-holder="Ingrese Apellido Materno"
          />
          <register-field-validation
            v-model="patient.user.email"
            :disabled="disabled_user_info"
            field-name="Correo Electrónico"
            :validation="emailValidation"
            place-holder="Ingrese Correo Electrónico"
          />
          <register-field-validation
            v-model="patient.user.phoneNumber"
            :disabled="disabled_user_info"
            field-name="Número de Celular"
            :validation="phoneValidation"
            place-holder="Ingrese un Número de Celular"
          />
          <directions-field
            v-model="patient.user.address"
            :disabled="disabled_user_info"
            field-name="Domicilio"
            place-holder="Ingrese domicilio"
            :obligatory="false"
            @changeAddress="updateDirection"
          />
          <picker-field
            v-model="patient.user.birthdate"
            :disabled="disabled_user_info"
            field-name="Fecha Nacimiento"
            :max="$config.birthdateValidation"
          />
        </v-container>
      </v-form>
    </v-card-subtitle>
    <buttons-register-form :disabled="disabled_patient_info" @saveUser="handleRegisterPatient" @cancel="cancelForm" />
    <br>
    <v-snackbar v-model="snackBar.show" :color="snackBar.color" text top>
      {{ snackBar.text }}
      <template #action="{ attrs }">
        <v-btn color="blue" text v-bind="attrs" @click="snackBar.show = false">
          <v-icon>mdi-window-close</v-icon>
        </v-btn>
      </template>
    </v-snackbar>
  </v-card>
</template>

<script>
import { mapActions, mapState } from 'vuex';
import RegisterFieldValidation from '~/components/InputField/RegisterFieldValidation';
import SelectField from '~/components/InputField/SelectField.vue';
import PickerField from '~/components/InputField/PickerField';
import ButtonsRegisterForm from '~/components/InputField/ButtonsRegisterForm.vue';
import imageField from '~/components/InputField/ImageField';
import DirectionsField from '~/components/InputField/DirectionsField';
import ConfirmationModal from '~/components/register/confirmationModal';
import {
  DNIRules,
  nameRules,
  fatherLastnameRules,
  motherLastnameRules,
  emailRules,
  imageFileRules,
  phoneRules,
  carnetRules,
  passportRules,
} from '~/helpers/validation';
import { imageDefault } from '~/helpers/constants';

export default {
  name: 'RegisterPatient',
  components: { RegisterFieldValidation, PickerField, ButtonsRegisterForm, imageField, ConfirmationModal, SelectField, DirectionsField },
  data: () => ({
    typeDocumentSelected: 'DNI',
    typesDocument: ['CARNET EXTRANJERÍA', 'DNI', 'PASAPORTE'],
    disabled_user_info: true,
    disabled_patient_info: true,
    isValidForm: false,
    DNIValidation: DNIRules,
    carnetValidation: carnetRules,
    passportValidation: passportRules,
    nameValidation: nameRules,
    fatherLastnameValidation: fatherLastnameRules,
    motherLastNameValidation: motherLastnameRules,
    phoneValidation: phoneRules,
    emailValidation: emailRules,
    imageValidation: imageFileRules,
    openModal: false,
    modalText: '¿Estás seguro que deseas registrar a este paciente?',
    snackBar: {
      show: false,
      color: '',
      text: '',
    },
    patient: {
      user: {
        image: null,
        document: '',
        typeDocument: '',
        name: '',
        fatherLastname: '',
        motherLastname: '',
        phoneNumber: '',
        address: '',
        email: '',
        birthdate: new Date().toISOString().substr(0, 10),
      },
      address: '',
    },
  }),

  computed: {
    ...mapState({
      checkedPatient: state => state.clientcompany.patient.checkedPatient,
      userAuth: state => state.auth.userAuth,
    }),
  },

  methods: {
    ...mapActions({
      savePatient: 'clientcompany/patient/registerPatient',
      getPatients: 'clientcompany/patient/getPatients',
      checkedInformationPatient: 'clientcompany/patient/checkedInformationPatient',
    }),
    async confirmRegister() {
      await this.register(this.patient);
      await this.$router.push('/pacientes');
    },

    cancelRegister() {
      this.openModal = false;
    },

    updateDirection(newAddress) {
      this.patient.user.address = newAddress.route;
    },

    handleRegisterPatient() {
      if (this.$refs.form.validate() && !this.disabled_patient_info) {
        this.openModal = true;
      }
    },
    async register(patient) {
      const formData = new FormData();
      if (this.patient.user.image === null) {
        fetch(imageDefault)
          .then(function (response) {
            return response.blob();
          })
          .then(function (blob) {
            formData.append('multipartFile', blob);
          });
      } else {
        formData.append('multipartFile', this.patient.user.image);
      }
      if (this.typeDocumentSelected === 'CARNET EXTRANJERÍA') {
        formData.append('typeDocument', 'CARNET');
      } else {
        formData.append('typeDocument', this.typeDocumentSelected);
      }
      formData.append('document', patient.user.document);
      formData.append('name', this.patient.user.name);
      formData.append('fatherLastname', this.patient.user.fatherLastname);
      formData.append('motherLastname', this.patient.user.motherLastname);
      formData.append('email', this.patient.user.email);
      formData.append('phoneNumber', this.patient.user.phoneNumber);
      formData.append('address', this.patient.user.address);
      formData.append('birthdate', this.patient.user.birthdate);
      const clientCompanyId = this.userAuth.clientSupervisor.company.id;
      formData.append('clientCompanyId', clientCompanyId);
      await this.savePatient({ patient: formData });
    },
    cancelForm() {
      this.clearForm();
      this.$router.push('/pacientes');
    },
    changeSELECT() {
      this.patient.user.document = '';
      this.clearForm();
    },
    async changeDNI(valid) {
      this.valid = valid;
      if (valid) {
        const checkedPatient = await this.checkedInformationPatient(this.patient.user.document);
        this.checkedUser(checkedPatient.data, this.typeDocumentSelected);
      } else {
        this.disabled_user_info = true;
        this.disabled_patient_info = true;
      }
    },
    async changeCarnetOrPassport(valid) {
      this.valid = valid;
      if (valid) {
        this.disabled_patient_info = false;
        const checkedpatient = await this.checkedInformationPatient(this.patient.user.document);
        this.checkedUserWithCarnetOrPassport(checkedpatient.data, this.typeDocumentSelected);
      } else {
        this.disabled_user_info = true;
        this.disabled_patient_info = true;
      }
    },

    checkedUser(patient, typeDocumentSelected) {
      this.clearForm();
      this.disabled_user_info = true;
      this.disabled_patient_info = true;

      /* If a user with this DNI doesn't exist */
      if (patient.user == null && patient.userApi == null) {
        this.setNackBar('El documento ' + typeDocumentSelected + ' no existe', 'error', true);
      }
      /* If a user found with API but doesn't register in BD */
      if (this.valid && patient.user == null && patient.userApi != null) {
        this.setNackBar(typeDocumentSelected + ' valido, complete los demás campos', 'primary', true);
        this.disabled_user_info = false;
        this.disabled_patient_info = false;
        this.patient.user.name = patient.userApi.nombres;
        this.patient.user.fatherLastname = patient.userApi.apellidoPaterno;
        this.patient.user.motherLastname = patient.userApi.apellidoMaterno;
      }

      /* If a user with this DNI exist. And this user is NOT a patient */
      if (this.valid && patient.user != null && !patient.isPatient) {
        this.ifUserRegisteredIsNotpatient(patient, typeDocumentSelected);
      }

      /* If a user with this DNI exist AND this user is a patient */
      if (this.valid && patient.user != null && patient.isPatient) {
        this.ifUserRegisteredIsPatient(patient, typeDocumentSelected);
      }
    },
    checkedUserWithCarnetOrPassport(patient, typeDocumentSelected) {
      this.clearForm();
      this.disabled_user_info = true;
      this.disabled_patient_info = true;

      /* If a user with this DNI is not registered in BD */
      if (this.valid && patient.user == null) {
        this.setNackBar(typeDocumentSelected + ' valido, complete los demás campos', 'primary', true);
        this.disabled_user_info = false;
        this.disabled_patient_info = false;
      }
      /* If a user with this DNI exist. And this user is NOT a patient */
      if (this.valid && patient.user != null && !patient.isPatient) {
        this.ifUserRegisteredIsNotpatient(patient, typeDocumentSelected);
      }
      /* If a user with this DNI exist AND this user is a patient */
      if (this.valid && patient.user != null && patient.isPatient) {
        this.ifUserRegisteredIsPatient(patient, typeDocumentSelected);
      }
    },
    ifUserRegisteredIsNotpatient(patient, typeDocumentSelected) {
      this.setNackBar(typeDocumentSelected + ' vinculado a un usuario. No es posible registrar este usuario.', 'blue', true);
      this.patient.user = patient.user;
      this.disabled_patient_info = true;
    },
    ifUserRegisteredIsPatient(patient, typeDocumentSelected) {
      this.setNackBar('El paciente ya se encuentra registrado con el documento ' + typeDocumentSelected, 'error', true);
      this.patient.user = patient.user;
    },
    setNackBar(text, color, show) {
      this.snackBar.text = text;
      this.snackBar.show = show;
      this.snackBar.color = color;
    },

    clearForm() {
      this.patient.user.name = '';
      this.patient.user.fatherLastname = '';
      this.patient.user.motherLastname = '';
      this.patient.user.email = '';
      this.patient.user.phoneNumber = '';
      this.patient.user.address = '';
      this.patient.user.birthdate = '';
      this.patient.address = '';
    },
  },
};
</script>
